#include "memory.h"
#include "letters.h"

void write_word(int address, int word) {
    int *a = (int*) address;
    *a = word;
}

void write_color(int address, char r, char g, char b) {
    write_byte(address, b);
    write_byte(address + 1, g);
    write_byte(address + 2, r);

}

void write_byte(int address, char byte) {
    char *a = (char*) address;
    *a = byte;
}

int read_word(int address) {
    int *a = (int*) address;
    return *a;
}

void* find_byte_sequence(char* sequence, int num, int base_address) {
    char* c = (char*) base_address;
    while (1) {
        if (*c == sequence[0]) {
            int i;
            for (i = 1; i < num; i++) {
                if (*(c + i) == sequence[i]) {

                } else {
                    break;
                }
                return (void*) c;
            }
        }
        c++;
    }
}

void paint_pixel(int x, int y, char r, char g, char b, int screen) {
    int coord = 720 * x + 720 - (y * 3);
    write_color(coord + screen, r, g, b);
}

void paint_letter(unsigned char letter, int x, int y, char r, char g, char b, int screen) {

    int i;
    int k;
    int c;
    unsigned char mask;
    unsigned char* _letter;
    unsigned char l;
    c = letter * 8;

    for (i = 0; i < 8; i++) {
        mask = 0b10000000;
        l = font[i + c];
        for (k = 0; k < 8; k++) {
            if ((mask >> k) & l) {
                paint_pixel(k + x, i + y, r, g, b, screen);
            }
        }
    }
}

int strlen(char* string) {
    int i;
    for (i = 0;; i++) {
        if (string[i] == 0x00) {
            return i;
        }
    }
}

void paint_word(char* word, int x, int y, char r, char g, char b, int screen) {
    int tmp_x = x;
    int i;
    int line = 0;

    for (i = 0; i < strlen(word); i++) {

        if (tmp_x + 8 > TOP_WIDTH) {
            line++;
            tmp_x = x;
        }
        paint_letter(word[i], tmp_x, y + (line * 8), r, g, b, screen);

        tmp_x = tmp_x + 8;
    }

}

void paint3Dword(char* word, int x, int y, char r, char g, char b, int offset3D) {
    int tmp_x = x;
    int i;
    int line = 0;

    //offset3D%=0x21; //offset limited to 32,-32

    for (i = 0; i < strlen(word); i++) {

        if (tmp_x + 8 > TOP_WIDTH) {
            line++;
            tmp_x = x;
        }
        paint_letter(word[i], tmp_x + offset3D, y + (line * 8), r, g, b, TOP_LEFT_FRAME1);
        paint_letter(word[i], tmp_x - offset3D, y + (line * 8), r, g, b, TOP_RIGHT_FRAME1);
        //paint_letter(word[i],tmp_x+offset3D,y+(line*8),r,g,b, TOP_LEFT_FRAME2);
        //paint_letter(word[i],tmp_x-offset3D,y+(line*8),r,g,b, TOP_RIGHT_FRAME2);

        tmp_x = tmp_x + 8;
    }

}

void hexDump(int start, int length,int y) {
    unsigned char* Gcv = (unsigned char*)start;
    unsigned char check = 0;
    int z = 0,W=255;
    unsigned char nib = 0;

    for (z = 0; z < length; z++) {
        if(z&1)W=255;else W=128;
        check = *Gcv;
       
         nib = (check & 255) >> 4; 
        if (nib < 10) {
            paint_letter(nib+48,  z*16, y, 0, W, 0, TOP_LEFT_FRAME1);
            paint_letter(nib+48,  z*16, y, 0, W, 0, TOP_LEFT_FRAME2);

        } else {
            nib-=10;
            paint_letter(nib+65,   z*16, y, 0, W, 0, TOP_LEFT_FRAME1);
            paint_letter(nib+65,   z*16, y, 0, W, 0, TOP_LEFT_FRAME2);
        }
         nib = (check & 255) & 15;
        if (nib < 10) {
            paint_letter(nib+48,   z*16+8, y, 0, W, 0, TOP_LEFT_FRAME1);
            paint_letter(nib+48,   z*16+8, y, 0, W, 0, TOP_LEFT_FRAME2);

        } else {
            nib-=10;
            paint_letter(nib+65,   z*16+8, y, 0, W, 0, TOP_LEFT_FRAME1);
            paint_letter(nib+65,   z*16+8, y, 0, W, 0, TOP_LEFT_FRAME2);
        }
        Gcv++;
        check=0;
        nib=0;
    }

}

